/**
 * Copyright (c) 2006-2009 Institut National de Recherche en Informatique et 
 *                         en Automatique. All rights reserved.
 * $COPYRIGHT$
 * 
 * Additional copyrights may follow
 * 
 * $HEADER$
 */

#ifndef SERVER_H_
#define SERVER_H_

#define MAX_HOST_NAME 256
#define ERROR -1
#define SUCCESS 0

#define MIN_ALLOC 10
#define MAX_IP 16
#define MAX_ADDR 256

#define MAX_BUFFER 1024
#define MAX_RESPONSE 256
#define MAX_PROC_ID 16



struct job_t {
  jobid_t jobid;
  sockaddr_t *processes;
  int alloc;  // memory allocated (in bytes)
  int size;  // size of the table
};
struct id {
    struct process_name_t process_name;
    struct sockaddr_t addr_OMPI;
    struct sockaddr_t addr_ORTE;
    struct id *id_next;
};

struct host{
    char host_name[MAX_HOST_NAME];
    struct id *ids;

};
struct cluster{
  int id;
  char frontale_name[MAX_HOST_NAME];
  TRAVERSING_CODE_t traversing_code;
  char proxy_name[MAX_HOST_NAME];
  char proxy_ip[MAX_IP];
  int proxy_port;
  int proxy_service_port;
  struct soap soap;
  int frontale_sockfd;
  struct host *hosts;
  int hosts_count;
  
 
};
#endif /*SERVER_H_*/
