/*
 * Shared Memory (SM) component instance. 
 */

mca_btl_sb_component_t mca_btl_sb_component = {
    {  /* super is being filled in */
        /* First, the mca_base_component_t struct containing meta information
          about the component itself */
        {
            /* Indicate that we are a pml v1.0.0 component (which also implies a
               specific MCA version) */
            MCA_BTL_BASE_VERSION_1_0_1,
            "sb", /* MCA component name */
            OMPI_MAJOR_VERSION,  /* MCA component major version */
            OMPI_MINOR_VERSION,  /* MCA component minor version */
            OMPI_RELEASE_VERSION,  /* MCA component release version */
            mca_btl_sb_component_open,  /* component open */
            mca_btl_sb_component_close  /* component close */
        },

        /* Next the MCA v1.0.0 component meta data */
        {
            /* Whether the component is checkpointable or not */
            false
        },

        mca_btl_sb_component_init,  
        mca_btl_sb_component_progress,
    }  /* end super */
};


/*
 * utility routines for parameter registration
 */

static inline char* mca_btl_sb_param_register_string(
    const char* param_name, 
    const char* default_value)
{
    char *param_value;
    int id = mca_base_param_register_string("btl","sb",param_name,NULL,default_value);
    mca_base_param_lookup_string(id, &param_value);
    return param_value;
}
                                                                                                                            
static inline int mca_btl_sb_param_register_int(
    const char* param_name, 
    int default_value)
{
    int id = mca_base_param_register_int("btl","sb",param_name,NULL,default_value);
    int param_value = default_value;
    mca_base_param_lookup_int(id,&param_value);
    return param_value;
}

/*
 *  Called by MCA framework to open the component, registers
 *  component parameters.
 */

int mca_btl_sb_component_open(void)
{

  /* initialize state */
  mca_btl_sb_component.sb_fd = -1;


  return OMPI_SUCCESS;

}



/*
 * component cleanup - sanity checking of queue lengths
 */

int mca_btl_sb_component_close(void)
{


  if(mca_btl_sb_component.sb_fd >= 0){
    fclose(fd);
    mca_btl_sb_component.sb_fd = -1;
  }
    /* cleanup any pending events */
    /* release resources */

    return OMPI_SUCCESS;
}

/*
 *  SB component initialization
 */
mca_btl_base_module_t** mca_btl_sb_component_init(
    int *num_ptls, 
    bool enable_progress_threads,
    bool enable_mpi_threads)
{


  /* nothing to do? */

    return btls;
}


/*
 *  SM component progress.
 */

#if OMPI_ENABLE_PROGRESS_THREADS == 1
void mca_btl_sb_component_event_thread(opal_object_t* thread)
{

}
#endif

int mca_btl_sb_component_progress(void)
{
    return OMPI_SUCCESS;
}

/**
 * Open the file that will be used to save the messages
 */
void mca_btl_sb_component_open_file(void){
  
  char *filename;

  asprintf(filename, "/tmp/sb_messages_%d", getpid());
  mca_btl_sb_component.sb_fd = fopen(filename, "a+");
  if(mca_btl_sb_component.sb_fd < 0)
    return errno;
  else
    return OMPI_SUCCESS;
}


mca_btl_base_module_t** mca_btl_sb_component_init(int *num_btl_modules, 
						  bool enable_progress_threads,
						  bool enable_mpi_threads)
{

  /* open the file */
  if(mca_btl_sb_component_open_file() != OMPI_SUCCESS)
    return 0;



}
